import { HttpClient } from '@angular/common/http';
import { OnInit } from '@angular/core';
import { AbstractControl, FormArray, FormControl, FormGroup } from '@angular/forms';
import { Observable } from 'rxjs';
import { Choice } from '../choice';
import { JsonSchemaFormService } from '../json-schema-form.service';
import { Schema } from '../schema';
import { State } from '../state';
import { KeyValue } from '@angular/common';
import * as i0 from "@angular/core";
/**
 * base component for all form elements
 */
export declare class BaseComponent implements OnInit {
    protected http: HttpClient;
    protected service: JsonSchemaFormService;
    /**
     * built-in formats
     */
    static formats: any;
    state: State;
    choices: Choice[];
    filteredOptions: Observable<Choice[]>;
    constructor(http: HttpClient, service: JsonSchemaFormService);
    ngOnInit(): void;
    setChoices(choices: any[]): void;
    _filter(value: string): Choice[];
    /**
     * cast control to primitive type
     */
    formControl(): FormControl;
    /**
     * case control to group / object
     */
    formGroup(): FormGroup;
    /**
     * case control to array
     */
    formArray(): FormArray;
    /**
     * create control and pass value to it
     */
    static createControl(schema: Schema, value: any, required: boolean): AbstractControl;
    static prepareControl(control: AbstractControl, schema: Schema, value: any, required: boolean): AbstractControl<any, any>;
    /**
     * angular pipe sorting function for keyValue - keep the JSON order and do not
     * order alphabetically
     */
    originalOrder: (a: KeyValue<string, Schema>, b: KeyValue<string, Schema>) => number;
    static ɵfac: i0.ɵɵFactoryDeclaration<BaseComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BaseComponent, "app-base", never, { "state": "state"; }, {}, never, never, false, never>;
}
